package Flier_Match.FMServidor;

import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.World;

public class MovingThread extends Thread{
	
	private boolean subiendo;
	private World JuegoRef;
	
    private int contadorAceleracion;//cuenta el numero de iteraciones para determinar si es tiempo de subir o bajar la velocidad
    private float velocidadTemp=0;
    
	public MovingThread (World aw) {
		JuegoRef=aw;
        
        contadorAceleracion=0;
        subiendo=false;

	}
	
	
	public void run () {
		
	}
	
	public void moverNave (Object3D referencia, int evento) {
		
	}
	
	public float [] manejarEventos (int eventos [], Object3D navePersonal, float Xrot, float Yrot) {
    	//log ("Manejando eventos");
    	boolean adelante=tieneEvento (1, eventos);
    	boolean atras=tieneEvento (2, eventos);
    	
    	if (adelante && atras) {// si se presiona atras y adelante al mismo tiempo
    		quitarEvento (1, eventos);
    		quitarEvento (2, eventos);
    		adelante=false;
    		atras=false;
    	}
    	if (!adelante && !atras) {// si se sueltan los controles de movimiento frontal
    		desacelerar (navePersonal);
    	}
    	
    	
        for (int i=0;i<eventos.length;i++) {
            hacerMovimientos (eventos [i],navePersonal);
            
            if (eventos [i]==3) {
            	Yrot-=ServerThread.velocidadGiro;
            } else if (eventos [i]==4) {
            	Yrot+=ServerThread.velocidadGiro;
            } else if (eventos [i]==5) {
            	Xrot=Xrot+2.86478898f;
            } else if (eventos [i]==6) {
            	Xrot-=2.86478898f;
            }
        }
        return (new float []{Xrot, Yrot});
    }
	
	public void hacerMovimientos (int i, Object3D navePersonal) {
        if (i==1) evento1 (navePersonal);
        if (i==2) evento2 (navePersonal);        
        if (i==3) evento3 (navePersonal);
        if (i==4) evento4 (navePersonal);
        if (i==5) evento5 (navePersonal);
        if (i==6) evento6 (navePersonal);
        if (i==7) evento7 (navePersonal);
        if (i==8) evento8 (navePersonal);
        if (i==9) evento9 (navePersonal);
        if (i==10) evento10 (navePersonal);
        if (i==11) evento11 (navePersonal);
        if (i==12) evento12 (navePersonal);
        if (i==13) evento13 (navePersonal);
        //System.out.println ("contador: "+contadorAceleracion+" - velocidad: "+velocidadTemp);
    }
	
	
	private void evento1 (Object3D navePersonal) {//adelante
        
    	if (subiendo==false){
    		subiendo=true;
    	}
        
        if (contadorAceleracion<30) contadorAceleracion++;
        
        if (contadorAceleracion<10 && contadorAceleracion>=0) velocidadTemp=ServerThread.velocidadNaveMin;
        else if (contadorAceleracion<20 && contadorAceleracion>=10) velocidadTemp=ServerThread.velocidadNaveMed;
        else if (contadorAceleracion<=30 && contadorAceleracion>=20) velocidadTemp=ServerThread.velocidadNaveMax;
                
        SimpleVector direccion=navePersonal.getZAxis ();
        direccion.scalarMul (velocidadTemp);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);

    }

    /**
     * Mueve la nave de reversa usando siempre la velocidad minima o desacelerando
     *
     */
    private void evento2 (Object3D navePersonal) {
    	
    	if (subiendo==true){
    		subiendo=false;
    	}
    	
    	if (contadorAceleracion>0) contadorAceleracion--;
    	
    	if (contadorAceleracion<10 && contadorAceleracion>0) velocidadTemp=ServerThread.velocidadNaveMin;
        else if (contadorAceleracion<20 && contadorAceleracion>=10) velocidadTemp=ServerThread.velocidadNaveMed;
        else if (contadorAceleracion<=30 && contadorAceleracion>=20) velocidadTemp=ServerThread.velocidadNaveMax;
        else if (contadorAceleracion==0) velocidadTemp=-ServerThread.velocidadNaveMin;
    	
        SimpleVector direccion=navePersonal.getZAxis ();
        direccion.scalarMul (velocidadTemp);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);

    }

    private void evento3 (Object3D navePersonal) {//giroIzq
        navePersonal.rotateAxis (navePersonal.getYAxis(), ServerThread.velocidadGiro);
    }

    private void evento4 (Object3D navePersonal) {//giroDer
        navePersonal.rotateAxis (navePersonal.getYAxis(), -ServerThread.velocidadGiro);
    }

    private void evento5 (Object3D navePersonal) {//giroArr
        navePersonal.rotateAxis (navePersonal.getXAxis(), -ServerThread.velocidadGiro);
    }

    private void evento6 (Object3D navePersonal) {//giroAba
        navePersonal.rotateAxis (navePersonal.getXAxis(), ServerThread.velocidadGiro);
    }

    private void evento7 (Object3D navePersonal) {//disparar bala

    }

    private void evento8 (Object3D navePersonal) {//disparar misil

    }

    private void evento9 (Object3D navePersonal) {//strafe izq con la velocidad minima
        SimpleVector direccion=navePersonal.getXAxis ();
        direccion.scalarMul (ServerThread.velocidadNaveMin);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);
        SimpleVector t2=temp.calcSub (direccion);

    }

    private void evento10 (Object3D navePersonal) {//strafe der con la velocidad minima
        SimpleVector direccion=navePersonal.getXAxis ();
        direccion.scalarMul (-ServerThread.velocidadNaveMin);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);
        SimpleVector t2=temp.calcSub (direccion);

    }

    private void evento11 (Object3D navePersonal) {//strafe arr con la velocidad minima
        SimpleVector direccion=navePersonal.getYAxis ();
        direccion.scalarMul (ServerThread.velocidadNaveMin);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);
        SimpleVector t2=temp.calcSub (direccion);

    }

    private void evento12 (Object3D navePersonal) {//strafe aba con la velocidad minima
        SimpleVector direccion=navePersonal.getYAxis ();
        direccion.scalarMul (-ServerThread.velocidadNaveMin);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);
        SimpleVector t2=temp.calcSub (direccion);

    }
    
    private void evento13 (Object3D navePersonal) {
        //salirNave ();
    }

    public boolean tieneEvento (int evt, int eventos []) {
    	for (int i=0;i<eventos.length;i++) {
    		if (eventos [i]==evt) return true;
    	}
    	return false;
    }
    
    public void quitarEvento (int evt, int eventos []) {
    	for (int i=0;i<eventos.length;i++) {
    		if (eventos [i]==evt) eventos [i]=-1;
    	}
    }
    
    private void desacelerar (Object3D navePersonal) {
    	//System.out.println ("desacelerando: "+navePersonal.getName());
    	if (contadorAceleracion>0) contadorAceleracion--;
    	
    	if (contadorAceleracion<10 && contadorAceleracion>0) velocidadTemp=ServerThread.velocidadNaveMin;
        else if (contadorAceleracion<20 && contadorAceleracion>=10) velocidadTemp=ServerThread.velocidadNaveMed;
        else if (contadorAceleracion<=30 && contadorAceleracion>=20) velocidadTemp=ServerThread.velocidadNaveMax;
        else if (contadorAceleracion==0) velocidadTemp=0;
    	
    	SimpleVector direccion=navePersonal.getZAxis ();
        direccion.scalarMul (velocidadTemp);
        SimpleVector temp=navePersonal.checkForCollisionEllipsoid (direccion, ServerThread.elipse, (int) (navePersonal.getScale ()*3));
        navePersonal.translate (temp);
    	
    }
    
}
