package Flier_Match.FMServidor;

import java.io.File;

import com.threed.jpct.Config;
import com.threed.jpct.Lights;
import com.threed.jpct.Loader;
import com.threed.jpct.Matrix;
import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.Texture;
import com.threed.jpct.TextureManager;
import com.threed.jpct.World;

public class ServerBuilder{

	private TextureManager Texman;
	
	public ServerBuilder () {
		//System.out.println("Inicio ServerThread");
		Config.maxPolysVisible=22000;
        World W=new World ();
        Object3D Mapa=new Object3D (0);
        
        Texman=TextureManager.getInstance ();
        texturas ("Recursos/Texturas/");
        texturas ("Recursos/Texturas/Colores/");
        
        Mapa=cargarMapa (W);
        Mapa.setName ("Mapa");
        //W.addObject (Mapa);
        W.setAmbientLight (180, 180, 180);
        W.getLights().setOverbrightLighting(Lights.OVERBRIGHT_LIGHTING_DISABLED);
        W.buildAllObjects ();
        
        ColisionesListener CL=new ColisionesListener ("Mapa");
        Mapa.addCollisionListener(CL);
        
        MovingThread movimientos=new MovingThread (W);
        movimientos.start ();
        ServerThread S=new ServerThread (W, movimientos);
        
        S.start ();
	}
	
	public void run () {
		
	}
	
	public static Object3D cargarMapa (World W) {
        Object3D Mapa=new Object3D (0);
        conf c=new conf ();
        //Object3D partes []=Loader.load3DS (c.getPath ()+"Recursos/Mapas/Valle Arido/ValleArido.3DS", 10f);
        Object3D partes []=Loader.load3DS (c.getPath ()+"Recursos/Mapas/Mapa Test/MTEST.3DS", 2f);
        for (int i=0;i<partes.length;i++) {
            Object3D part=partes [i];

                part.setCenter(SimpleVector.ORIGIN);
                part.rotateX((float)-Math.PI/2);
                part.rotateMesh();
                part.setRotationMatrix(new Matrix());
                if ((i&1)==1) part.setTransparency(1);
                
                if (!part.getName().startsWith("LIMITE")) {
                	Mapa=Object3D.mergeObjects (Mapa, part);
                }else {
                	part.setTexture("COLOR.JPG");
                	part.setTransparency(0);
                	part.setCollisionMode(Object3D.COLLISION_CHECK_OTHERS | Object3D.COLLISION_CHECK_SELF);
                	W.addObject(part);
                }
                
        }
        Mapa.setCollisionMode (Object3D.COLLISION_CHECK_OTHERS | Object3D.COLLISION_CHECK_SELF);
        W.addObject(Mapa);
        return Mapa;
    }
    
    public void texturas (String FileDir) {
        conf c=new conf ();
        File dir=new File (c.getPath()+FileDir);
        String names []=dir.list ();
        for (int i=0;i<names.length;i++) {
        	if (names[i].endsWith("jpg") || names[i].endsWith("JPG"))Texman.addTexture (names[i], new Texture (c.getPath ()+FileDir+names [i]));
        }
    }
	
}
