/*
 * ServerThread.java
 *
 * Created on 11 de marzo de 2006, 15:49
 */

package Flier_Match.FMServidor;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

import Flier_Match.FMRed.ListaRed;

import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.World;
/**
 *
 * @author  Administrador
 * @version 
 */
public class ServerThread extends Thread{
    
    private ServerSocket Maestro;
    
    private boolean salida;
    
    private World Juego;
    public ListaRed jugadores;
    public static float velocidadNaveMin;//es la velocidad minima
    public static float velocidadNaveMed;//es la velocidad media
    public static float velocidadNaveMax;//es la velocidad maxima
    public static float velocidadDisparo;
    public static float velocidadMisil;
    public static float velocidadGiro;
    static SimpleVector elipse;
    
    static int tempColor;
    static int idTemp;
    
    private ArrayList atenciones;
    private PublicadorCambios cambios;
    
    public static final int esperaThreadAtencion=60;
    
    public static int daoBala1=30;
    public static int daoMisil1=100;
    
    private MovingThread MT;
    
    /** Creates new ServerThread */
    public ServerThread(World Ju, MovingThread movimientos) {
    	
    	atenciones=new ArrayList ();
    	
        Juego=Ju;
        MT=movimientos;
        
        salida=false;
        jugadores=new ListaRed ();
        velocidadNaveMax=6f;
        velocidadNaveMed=3.5f;
        velocidadNaveMin=2f;
        velocidadDisparo=20f;
        velocidadMisil=15f;
        velocidadGiro=0.05f;
        elipse=new SimpleVector (32, 6, 16);
        
        try {
            Maestro=new ServerSocket (8888);
        } catch (Exception E) {
            System.out.println ("Error creando el ServerSocket: "+E.getMessage());
            E.printStackTrace ();
        }
        
        cambios=new PublicadorCambios (atenciones);

    }
    
    public void run () {
        while (!salida) {
            System.out.println ("El servidor esta atendiendo");
            Socket cliente=null;
            try {
                cliente=Maestro.accept ();
                System.out.println ("Atencion solicitada");
            } catch (Exception E) {
                System.out.println ("Error al aceptar la conexion: "+E.getMessage());
                //E.printStackTrace();
            }
            
            if (cliente!=null){
                Atencion personal=new Atencion (cliente, jugadores, Juego, MT, cambios);
                personal.setPriority (Thread.MAX_PRIORITY);
                personal.start ();
                atenciones.add(personal);
            }
        }
    }

    
    public void salir () {
        salida=true;
    }
}
